<!DOCTYPE html>
<html lang="zh-CN">
<head>
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=0, minimal-ui">
    <title>{lang_admin('view_the_license_agreement')}</title>
    <link rel="shortcut icon" href="{$base_url}/favicon.ico" type="image/x-icon" />
    <!-- 调用样式表 -->
    <link href="{$base_url}/common/css/bootstrap/bootstrap-3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="{$base_url}/common/font/simple/css/font.css" rel="stylesheet" type="text/css"/>
    <script src="{$base_url}/common/js/jquery/jquery.min.js"></script>
    <script type="text/javascript">
        //div的滚动条滚动事件
        function doScroll(){
            //获取协议和按钮的DOM
            var d = document.getElementById('license');
            var btn = document.getElementById('agree');
            //判断是否滚动到最底部了
            if(d.scrollTop + d.offsetHeight > 518){
                btn.disabled = false;//恢复按钮可用
            }
        }
    </script>
    <style type="text/css">
        body {
            font-size:14px;
            line-height:180%;
            background:#EEEEEE;
            overflow-x:hidden;
        }
        a:link {
            text-decoration:none;
        }
        a:visited {
            text-decoration:none;
        }
        a:hover {
            text-decoration:none;
        }
        a:active {
            text-decoration:none;
        }
        * {
            outline: none;
        }
        :focus {
            outline:none;
        }
        .modal-backdrop {
            opacity: 0 !important;
            filter: alpha(opacity=0) !important;
        }
        .modal-backdrop {z-index: -1 !important;}
        .modal-content {box-shadow:none !important; border:none !important;}
        .modal-body {padding:0px !important;}
        .modal-dialog {width:100% !important;}
        .modal {position: relative;}
        .btn:focus,
        .btn:active:focus,
        .btn.active:focus,
        .btn.focus,
        .btn:active.focus,
        .btn.active.focus {
            outline: none;
            border-color: transparent;
            box-shadow:none;
        }
        .install {
            position: relative;
            left:0; right:0;
            z-index:999;
            margin: 15px auto;
            max-width: 786px;
        }
        @media (max-width: 768px) {
            .install {
                width:100%;
            }
        }
        .version {float:right; font-size:8px;color:#888;padding-bottom: 10px;}
        .install-box {
            background-color: white;
            border: 1px solid #e5e5e5;
            border-radius: 2px;
            clear: both;
            background-color: #fff;
            box-shadow: 0 .126rem .26rem rgba(0,0,0,.066)!important;box-sizing: border-box;
            padding: 0px 25px 25px 25px;
        }
        .logo {
            text-align: center;
            margin: 50px 0px 5px 0px;
            padding-bottom:25px;
            border-bottom:1px solid #eee;
        }
        .logo img {width:188px;}
        .form-group label {position: relative;}
        .tips {
            color: #ccc;
            cursor:help
        }
        .tooltip {
            width:188px;
            text-align:left;
        }
        .install-content h3 {margin:15px 0px;padding:15px 0px;border-bottom:1px solid #eee;font-size: 150%;
            line-height: 150%;font-weight:500;}
        .form-control {border-radius: 2px;}
        .blank5, .blank10, .blank20,.blank30 { clear: both; height: 5px; }
        .blank10 { height: 10px; }
        .blank20 { height: 20px; }
        .blank30 { height: 30px; }
        .padding10 { padding: 10px; }
        .readpact {margin:15px;padding:15px 0px;border-top:1px solid #eee;}
        .readpact label a {color: #666; font-weight:normal; font-size:0.8rem;}
        .install-content .btn {background:#fff;border:1px solid #ccc;border-radius: 2px;}
        .install-content .btn-install {color: #fff;
            background-color: #06276a;
            border-color: #06276a;font-size: 1.385rem;
            height: 3.385rem;
            padding: 0 1.538rem;
            border-radius: 2px;
        }
        .install-content .btn-install:hover {opacity: 0.8;}
        .copy {font-size:0.8rem;color:#ccc;padding:10px 0px;text-align: center;}
        .copy a {color:#ccc;}
        .modal-content {border-radius: 2px !important;}
        .tooltip > p {text-align: left;}
        .tooltip-inner {
            text-align:left;
        }
        #license {width:100%; height: 588px; padding:10px 0px 10px 10px; background:#eee;border:1px solid #CCC;line-height:200%; overflow-x: hidden; overflow-y: auto;}
        #license h1 {font-size:28px;}
        .go {background:url({$skin_admin_path}/images/go_1.gif) center top no-repeat;}
        .agreement { color:#555;}

        .license-title {font-weight: bold;}
        /*.line-text-blue {color:blue;}*/
        .tips-p {color:#ccc; font-size:12px;}
    </style>
</head>
<body>
<div class="container">
    <div class="install">
        <small class="version">V.<?php echo _VERCODE;?></small>
        <div class="install-box">
            <div class="logo">
                <a href="https://www.cmseasy.cn/" target="_blank"><img src="./images/logo.png"></a>
            </div>
            <div class="install-content">
                <div id="license" onscroll="doScroll()">
                    <div style="padding:10px 10px 10px 15px;background:white;">
                        <div class="agreement">
                            <div class="padding10">
                                <?php
                                include './template_admin/admin/index/license.php';
                                ?>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>
                </div>
                <div class="blank30"></div>

                <center>
                    <p class="tips-p"><i class="icon-info"></i> 请下拉滚动条阅读协议内容后安装</p>
                    <input type="checkbox" value="1" id="readpact" name="license_pass">
                    <label for="readpact">
                        {lang_admin('i_have_read_and_agreed_to_this_agreement')}
                    </label>
                    <input id="agree" class="btn btn-primary" style="margin-left:20px;background-color: #06276a; color:#fff; border-radius:3px; padding:8px 58px; border:none; " type="button" onclick="if(!document.getElementById('readpact').checked) {alert('{lang_admin('you_must_agree_to_the_software_license_agreement_to_install')}！'); return false;}else{window.location.href='<?php echo url('install/index',true); ?>';}" value="{lang_admin('start_installation')}"  disabled="" />
                </center>

                <div class="blank10"></div>
            </div>
        </div>
    </div>
    <div class="clearfix copy">{getCopyRight()}</div>
</div>
<script src="{$base_url}/common/css/bootstrap/bootstrap-3.3.7/js/bootstrap.min.js"></script>
</body>
</html>